/*******************************************************************************
 * ZeCurlSubsystem generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class ZeCurlSubsystem extends Object
    native;

enum EWebRequestType
{
    EWRT_INVALID,
    EWRT_GET,
    EWRT_POST,
    EWRT_PUT,
    EWRT_DELETE,
    EWRT_MAX
};

struct native HttpHeader
{
    var init string Key;
    var init string Value;

    structdefaultproperties
    {
        Key=""
        Value=""
    }
};

struct native HTTPRequestInput
{
    var init string RequestURL;
    var init string RequestSSLCert;
    var init string RequestSSLKey;
    var init array<init byte> RequestPOSTData;
    var init array<init HttpHeader> RequestHeaderData;
    var ZeCurlSubsystem.EWebRequestType RequestType;

    structdefaultproperties
    {
        RequestURL=""
        RequestSSLCert=""
        RequestSSLKey=""
        RequestPOSTData=none
        RequestHeaderData=none
        RequestType=EWebRequestType.EWRT_INVALID
    }
};

struct native LibCurlRequestData
{
    var HTTPRequestInput RequestInput;
    var int RequestHandle;
    var Pointer OutData;
    var int OutSize;
    var delegate<OnLibCurlReadComplete> CompletedDelegate;
    var byte ErrorData[256];

    structdefaultproperties
    {
        RequestInput=(RequestURL="",RequestSSLCert="",RequestSSLKey="",RequestPOSTData=none,RequestHeaderData=none,RequestType=EWebRequestType.EWRT_INVALID)
        RequestHandle=0
        OutData=none
        OutSize=0
        mplet=None
        ErrorData[0]=0
        ErrorData[1]=0
        ErrorData[2]=0
        ErrorData[3]=0
        ErrorData[4]=0
        ErrorData[5]=0
        ErrorData[6]=0
        ErrorData[7]=0
        ErrorData[8]=0
        ErrorData[9]=0
        ErrorData[10]=0
        ErrorData[11]=0
        ErrorData[12]=0
        ErrorData[13]=0
        ErrorData[14]=0
        ErrorData[15]=0
        ErrorData[16]=0
        ErrorData[17]=0
        ErrorData[18]=0
        ErrorData[19]=0
        ErrorData[20]=0
        ErrorData[21]=0
        ErrorData[22]=0
        ErrorData[23]=0
        ErrorData[24]=0
        ErrorData[25]=0
        ErrorData[26]=0
        ErrorData[27]=0
        ErrorData[28]=0
        ErrorData[29]=0
        ErrorData[30]=0
        ErrorData[31]=0
        ErrorData[32]=0
        ErrorData[33]=0
        ErrorData[34]=0
        ErrorData[35]=0
        ErrorData[36]=0
        ErrorData[37]=0
        ErrorData[38]=0
        ErrorData[39]=0
        ErrorData[40]=0
        ErrorData[41]=0
        ErrorData[42]=0
        ErrorData[43]=0
        ErrorData[44]=0
        ErrorData[45]=0
        ErrorData[46]=0
        ErrorData[47]=0
        ErrorData[48]=0
        ErrorData[49]=0
        ErrorData[50]=0
        ErrorData[51]=0
        ErrorData[52]=0
        ErrorData[53]=0
        ErrorData[54]=0
        ErrorData[55]=0
        ErrorData[56]=0
        ErrorData[57]=0
        ErrorData[58]=0
        ErrorData[59]=0
        ErrorData[60]=0
        ErrorData[61]=0
        ErrorData[62]=0
        ErrorData[63]=0
        ErrorData[64]=0
        ErrorData[65]=0
        ErrorData[66]=0
        ErrorData[67]=0
        ErrorData[68]=0
        ErrorData[69]=0
        ErrorData[70]=0
        ErrorData[71]=0
        ErrorData[72]=0
        ErrorData[73]=0
        ErrorData[74]=0
        ErrorData[75]=0
        ErrorData[76]=0
        ErrorData[77]=0
        ErrorData[78]=0
        ErrorData[79]=0
        ErrorData[80]=0
        ErrorData[81]=0
        ErrorData[82]=0
        ErrorData[83]=0
        ErrorData[84]=0
        ErrorData[85]=0
        ErrorData[86]=0
        ErrorData[87]=0
        ErrorData[88]=0
        ErrorData[89]=0
        ErrorData[90]=0
        ErrorData[91]=0
        ErrorData[92]=0
        ErrorData[93]=0
        ErrorData[94]=0
        ErrorData[95]=0
        ErrorData[96]=0
        ErrorData[97]=0
        ErrorData[98]=0
        ErrorData[99]=0
        ErrorData[100]=0
        ErrorData[101]=0
        ErrorData[102]=0
        ErrorData[103]=0
        ErrorData[104]=0
        ErrorData[105]=0
        ErrorData[106]=0
        ErrorData[107]=0
        ErrorData[108]=0
        ErrorData[109]=0
        ErrorData[110]=0
        ErrorData[111]=0
        ErrorData[112]=0
        ErrorData[113]=0
        ErrorData[114]=0
        ErrorData[115]=0
        ErrorData[116]=0
        ErrorData[117]=0
        ErrorData[118]=0
        ErrorData[119]=0
        ErrorData[120]=0
        ErrorData[121]=0
        ErrorData[122]=0
        ErrorData[123]=0
        ErrorData[124]=0
        ErrorData[125]=0
        ErrorData[126]=0
        ErrorData[127]=0
        ErrorData[128]=0
        ErrorData[129]=0
        ErrorData[130]=0
        ErrorData[131]=0
        ErrorData[132]=0
        ErrorData[133]=0
        ErrorData[134]=0
        ErrorData[135]=0
        ErrorData[136]=0
        ErrorData[137]=0
        ErrorData[138]=0
        ErrorData[139]=0
        ErrorData[140]=0
        ErrorData[141]=0
        ErrorData[142]=0
        ErrorData[143]=0
        ErrorData[144]=0
        ErrorData[145]=0
        ErrorData[146]=0
        ErrorData[147]=0
        ErrorData[148]=0
        ErrorData[149]=0
        ErrorData[150]=0
        ErrorData[151]=0
        ErrorData[152]=0
        ErrorData[153]=0
        ErrorData[154]=0
        ErrorData[155]=0
        ErrorData[156]=0
        ErrorData[157]=0
        ErrorData[158]=0
        ErrorData[159]=0
        ErrorData[160]=0
        ErrorData[161]=0
        ErrorData[162]=0
        ErrorData[163]=0
        ErrorData[164]=0
        ErrorData[165]=0
        ErrorData[166]=0
        ErrorData[167]=0
        ErrorData[168]=0
        ErrorData[169]=0
        ErrorData[170]=0
        ErrorData[171]=0
        ErrorData[172]=0
        ErrorData[173]=0
        ErrorData[174]=0
        ErrorData[175]=0
        ErrorData[176]=0
        ErrorData[177]=0
        ErrorData[178]=0
        ErrorData[179]=0
        ErrorData[180]=0
        ErrorData[181]=0
        ErrorData[182]=0
        ErrorData[183]=0
        ErrorData[184]=0
        ErrorData[185]=0
        ErrorData[186]=0
        ErrorData[187]=0
        ErrorData[188]=0
        ErrorData[189]=0
        ErrorData[190]=0
        ErrorData[191]=0
        ErrorData[192]=0
        ErrorData[193]=0
        ErrorData[194]=0
        ErrorData[195]=0
        ErrorData[196]=0
        ErrorData[197]=0
        ErrorData[198]=0
        ErrorData[199]=0
        ErrorData[200]=0
        ErrorData[201]=0
        ErrorData[202]=0
        ErrorData[203]=0
        ErrorData[204]=0
        ErrorData[205]=0
        ErrorData[206]=0
        ErrorData[207]=0
        ErrorData[208]=0
        ErrorData[209]=0
        ErrorData[210]=0
        ErrorData[211]=0
        ErrorData[212]=0
        ErrorData[213]=0
        ErrorData[214]=0
        ErrorData[215]=0
        ErrorData[216]=0
        ErrorData[217]=0
        ErrorData[218]=0
        ErrorData[219]=0
        ErrorData[220]=0
        ErrorData[221]=0
        ErrorData[222]=0
        ErrorData[223]=0
        ErrorData[224]=0
        ErrorData[225]=0
        ErrorData[226]=0
        ErrorData[227]=0
        ErrorData[228]=0
        ErrorData[229]=0
        ErrorData[230]=0
        ErrorData[231]=0
        ErrorData[232]=0
        ErrorData[233]=0
        ErrorData[234]=0
        ErrorData[235]=0
        ErrorData[236]=0
        ErrorData[237]=0
        ErrorData[238]=0
        ErrorData[239]=0
        ErrorData[240]=0
        ErrorData[241]=0
        ErrorData[242]=0
        ErrorData[243]=0
        ErrorData[244]=0
        ErrorData[245]=0
        ErrorData[246]=0
        ErrorData[247]=0
        ErrorData[248]=0
        ErrorData[249]=0
        ErrorData[250]=0
        ErrorData[251]=0
        ErrorData[252]=0
        ErrorData[253]=0
        ErrorData[254]=0
        ErrorData[255]=0
    }
};

var private native const noexport Pointer VfTable_FTickableObject;
var private array<Pointer> HandlePool;
var private array<Pointer> PendingRequestData;
var private array<LibCurlRequestData> CompletedRequestData;
var delegate<OnLibCurlReadComplete> __OnLibCurlReadComplete__Delegate;

delegate OnLibCurlReadComplete(const out LibCurlRequestData CompletedRequest)
{
    //return;    
}

// Export UZeCurlSubsystem::execSendRequest(FFrame&, void* const)
native function bool SendRequest(const out HTTPRequestInput Input, out array<byte> OutData);

// Export UZeCurlSubsystem::execSendRequestAsync(FFrame&, void* const)
native function int SendRequestAsync(const out HTTPRequestInput Input);

// Export UZeCurlSubsystem::execGetCompletedRequest(FFrame&, void* const)
native function bool GetCompletedRequest(const int InHandle, out LibCurlRequestData OutRequest);

// Export UZeCurlSubsystem::execInitialize(FFrame&, void* const)
private native final function bool Initialize();

// Export UZeCurlSubsystem::execRelease(FFrame&, void* const)
private native final function bool Release();

// Export UZeCurlSubsystem::execGetEscapedString(FFrame&, void* const)
native function string GetEscapedString(const out string Input);

// Export UZeCurlSubsystem::execGetUnEscapedString(FFrame&, void* const)
native function string GetUnEscapedString(const out string Input);

// Export UZeCurlSubsystem::execGetHandle(FFrame&, void* const)
native function Pointer GetHandle();

// Export UZeCurlSubsystem::execReleaseHandle(FFrame&, void* const)
native function ReleaseHandle(Pointer InHandle);

// Export UZeCurlSubsystem::execHasPendingRequests(FFrame&, void* const)
native function bool HasPendingRequests();

// Export UZeCurlSubsystem::execWaitForAllRequests(FFrame&, void* const)
native function WaitForAllRequests();
